using System;
using System.IO;
using System.IO.Compression;

namespace Steganografi
{
    class DecompressHelper 
    {
        /// <summary>
        /// melakukan dekompresi dari array of byte, dan menyimpannya dalam fileout
        /// </summary>
        /// <param name="bfile">array of byte the file that would be decompressed</param>
        /// <param name="fileout">the name (path) of the destination decompressed file</param>
        /// <returns></returns>
        public static byte[] DecompressByte(byte[] compressfile, UInt32 size)
        {
            using (Stream str = new MemoryStream())
            {
                byte[] buff = new byte[size];
                // write bytes to stream.
                str.Write(compressfile, 0, compressfile.Length);
                str.Position = 0;   // reset stream position.

                GZipStream zipstream = new GZipStream(str, CompressionMode.Decompress); // decompress.
                int totalCount = DecompressHelper.ReadAllBytesFromStream(zipstream, buff);
                zipstream.Close();

                return buff;
            }
        }

        /// <summary>
        /// membaca seluruh byte dari stream dan di buffer ke dalam variabel buffer
        /// </summary>
        /// <param name="stream">stream to be read</param>
        /// <param name="buffer">buffer to save</param>
        /// <returns>jumlah byte yang dibaca</returns>
        public static int ReadAllBytesFromStream(Stream stream, byte[] buffer)
        {
            int totalCount = 0;
            totalCount = stream.Read(buffer,0,buffer.Length);
            return totalCount;
        }
    }
}
